#ifndef __UTIL_H__
#define __UTIL_H__

#include "sparse.h"

//      CRS (3 ,   )
//     Value, Col  RowIndex
//    mtx
void InitializeMatrix(int N, int NZ, crsMatrix &mtx);

//     mtx
void FreeMatrix(crsMatrix &mtx);

//   imtx  omtx,     Value, Col  RowIndex
void CopyMatrix(crsMatrix imtx, crsMatrix &omtx);

//  2     CRS (3 ,   )
//  max|Cij|,  C = A - B
//    : 0 - , 1 -    (N)
int CompareMatrix(crsMatrix mtx1, crsMatrix mtx2, double &diff);

//  2     CRS (3 ,   )
//  max|Cij|,  C = A - B
//      MKL
//    : 0 - , 1 -    (N)
int SparseDiff(crsMatrix A, crsMatrix B, double &diff);

//  2     CRS (3 ,   )
//  C = A * B, C -   CRS (3 ,   )
//                         C     
//    : 0 - , 1 -    (N)
//   
int SparseMKLMult(crsMatrix A, crsMatrix B, crsMatrix &C, double &time);

//      CRS (3 ,   )
//    cntInRow  
void GenerateRegularCRS(int seed, int N, int cntInRow, crsMatrix& mtx);

//      CRS (3 ,   )
//        1  cntInRow
//   -  
void GenerateSpecialCRS(int seed, int N, int cntInRow, crsMatrix& mtx);

#endif // __UTIL_H__