//      CRS
//  :     50   
//     
//  B: -        , 
//        - (50)  
//        

// *****  3 -  ""  *****

#include <stdio.h>
#include <stdlib.h>
#include "util.h"
#include "sparse.h"

const double EPSILON = 0.000001;

// argv[1] -  
// argv[2] -        
int main(int argc, char *argv[])
{
  if (argc < 3)
  {
    printf("Invalid input parameters\n");
    return 1;
  }
  
  int N = atoi(argv[1]);
  int NZ = atoi(argv[2]);

  if ((NZ > N) || (N <= 0) || (NZ <= 0))
  {
    printf("Incorrect arguments of main\n");
    return 1;
  }

  crsMatrix A, B, BT, C;

  GenerateRegularCRS(1, N, NZ, A);
  GenerateSpecialCRS(2, N, NZ, B);

  double timeT = Transpose2(A, BT);
  double timeM, timeM1;
//  Multiplicate(B, BT, C, timeM);
  Multiply(B, BT, C, timeM);

  crsMatrix CM;
  double diff;

  SparseMKLMult(B, A, CM, timeM1);
  SparseDiff(C, CM, diff);
  if (diff < EPSILON)
    printf("OK\n");
  else
    printf("not OK\n");
  printf("%d %d %d %d\n", A.N, A.NZ, B.NZ, C.NZ);
  printf("%.3f %.3f %.3f\n", timeT, timeM, timeM1);

  FreeMatrix(A);
  FreeMatrix(B);
  FreeMatrix(BT);
  FreeMatrix(C);
  FreeMatrix(CM);

  return 0;
}
